// Sceth (c) 2007 Tom Hall. GNU licence.
// reg@ludions.com
// requires the file time2secs.sc
// for honking (OSX only), requires honk.sc
// honk.sc available at www.ludions.com/sc/
// version 2007-07-27
// Latest version available at www.ludions.com/sc/

Sceth : Scet {
	
	var honkArr, honkVal;
	
	honk_ {|bool= true| ^honkVal = bool}
	
	honk {^honkVal}
	
	doHonk {|msg| msg.honk(*this.honkDisp) }
	
	honkDisp_ {
		arg p=3, h=0.1, w = 0.875, x=0, y=0.9, o=0.640, 
			f="yellow", b="gray";
		^honkArr = [p, h, w, x, y, o, f, b];
	}
	
	honkDisp {^honkArr}
	
	initScet { arg  aTimesArr, aLoop;
		 super.initScet(aTimesArr, aLoop);
		 this.honk_(true); // for Sceth only
		 this.honkDisp_ ; // fill with default vals;
	}
	
	stop {
		if (r.isPlaying, {
			if (this.honk, {
				this.doHonk("endSceth")}
			)}
		);
		super.stop;
	}
	
	taskFinished { 
		super.taskFinished;
		if(this.honk, {this.doHonk("endSceth")});
	}	
	
	// main fn
	// includes calls to honk, otherwise same as in Scet
	routine { 		
		r = Task({
			(totalTime).do{ |i|  
				currTime = i;
				notInRout = false;
				// looks to see if current second is at section boundary
				remind = secsArr.includes(i+1);
				lastIter = i == (totalTime-1);
				{ btn.value =  1 }.defer; // set play to reset
				
				if (i==0, {
					currSectionInd = 0;
					currSection = names[0];
					if (snd) { this.playSynth };
					if(this.honk && (loopedTime==0), {
						this.doHonk(currSection)
					});
				// play tick if applies, with melody if wildcard
				// don't play if another reminder melody would play
				}, {
					if ((tick.notNil && remind.not), {
						if (((i%tick==0) && (lastIter.not)), {
							if (wild, {
								this.alert(false, true);
							}, {
								this.playSynth; 
							});
						});
					});
				});
				
				if (i==nextTxtUpdate, {
					currSectionDur = secsDiffs[currSectionInd];
					this.setMsg(currSection, currSectionDur);
				});
				
				currSctnBeat = i-nextTxtUpdate;
				currSctnBeatsRem = currSectionDur-currSctnBeat;
								
				// reminder(s)
				// remind means curr second at section boundary
				if (remind, {
					if (lastIter, {
						this.alert(false, false);
						if(loop && (this.honk), {
							this.doHonk(names.first)
						});
					}, {	
						// boolean sets style of synth sequence
						currSectionInd = secsArr.indexOf(i+1)+1;
						currSection = names[currSectionInd];
						this.alert(true, false);
						if (this.honk, {this.doHonk(currSection)});
						nextTxtUpdate = i+1;
					});
				});				
				
				this.setSlider(i, dir);	
				
				if (toggle, {
					this.setText(loopedTime + i, false);
				}, {
					this.setText(currSctnBeatsRem, false);
				});
				
				// for looping
				if (loop && (i == (totalTime-1)), {
					loopedTime = loopedTime + totalTime;
					nextTxtUpdate = 0;
					1.yieldAndReset(loop);
				}, {
				1.wait
				});	
			};
		this.taskFinished
		});
	}

	
	
}


