// Scet (c) 2007 Tom Hall. GNU licence.
// reg /*at*/ ludions /*dot*/ com 
// requires the file time2secs.sc
// for honking (OSX only AFAIK), requires honk.sc
// honk.sc available at www.ludions.com/sc/
// version 2007-07-27
// Latest version available at www.ludions.com/sc/

Scet {

	classvar <allScets;

	var winSize, server, <>names, snd=false, tick, wild;
	var dir=false, vol, currSectionInd, winBoundsCurr; 
	var alert, timePaused=0, text, win, winFn;
	var setText, eggPause, endText, btn4, screenRes;
	var totalTime, color, info, btn, btn3, r;
	var setMsg, currSection, secsArr, secsDiffs;
	var isPaused=false, notInRout=false, remind;
	var slide, lastIter, setSlider, nextTxtUpdate;
	var currSctnBeat, currSctnBeatsRem, loopedTime, currTime;
	var <>toggle = false, loop, timesArr, currSectionDur;

	*initClass { 
		StartUp.add {
			SynthDef.writeOnce("ScetPing", { 
				arg out=0, freq=1600, sustain=0.05, amp=0.3, pan=0;
				var env, snd;
				env = EnvGen.kr(
					Env.perc(0.01, sustain, 0.2), doneAction:2
				);
				snd = SinOsc.ar(freq, 0, env);
				Out.ar(out, Pan2.ar(snd, pan,  amp))
			});
		allScets = [];
		};
	}

	*new { arg timesArr, loop;	
		^super.new.initScet(timesArr, loop)
	}
	
	*closeAll { allScets.copy.do({|i| i.close }) } 

	initScet { arg  aTimesArr, aLoop;
		 loop = aLoop ? false;
		 screenRes = this.resolution;
		 winSize = [112, 55];
		 loopedTime = 0;
		 nextTxtUpdate = 0;
		 this.arrays(aTimesArr);
		 names = this.makeNames;
		 this.winFn(dir);
		 allScets = allScets.add(this);
		 this.routine;	 
		 CmdPeriod.doOnce {
		 	this.stop; 
		 	this.close;
			(this.species.asString ++ 
				" cannot survive cmd+., closing...").postln;
		 }
	}

	arrays { | arr |
		if(arr.isNil, {arr = 1});
		timesArr = if(arr.isKindOf(Number), { arr.bubble}, {arr});
		secsArr = timesArr.collect{|i| i.time2secs}.sort;
		secsDiffs = secsArr.differentiate;
		//	["secsArr size: ", secsArr.size].postln;
		//	[secsArr, 	secsDiffs].postln;
		totalTime = secsArr.last;
	}


	makeNames {
		var arr;
		arr = [];
		(timesArr.size).do{|i| 
			arr = arr.add("Part "++((i+1).asString))
		};
		^arr;
	}

	// pause timer
	pause { 
		if ((r.wasStopped  || notInRout
			), {
			// [r.wasStopped, notInRout].pl;
			"Task not running".postln;
			{ btn.value = 0 }.defer; 
		}, {
			{ info.string = 
				(loopedTime + timePaused.ceil + currTime).asTimeString1; 
			}.defer;
			{ btn.value = 0 }.defer;
			r.pause; 
			isPaused = true;
			eggPause = thisThread.seconds;
	//		["eggPauseTime:"+eggPause].pl;
			"Paused";
		});
	}

	// resume timer after pause
	resume  {
		var timeStr, resumeTime;
		if (isPaused.not, {
			"Task not paused".postln;
		}, {
			if (notInRout, {
				this.play;
			}, {
			this.setMsg(currSection, currSectionDur);
			resumeTime = thisThread.seconds;
	//		["timePaused-Existing:"+timePaused].postln;
	//		["pauseResumeTime:"+resumeTime].postln;
			timePaused = timePaused + (resumeTime-eggPause);
			timeStr = timePaused.asTimeString1;
			("Total pause(s): "++timeStr).postln;
			isPaused=false;
			r.resume;
			});
		});
	}


	play {
		if (notInRout, {
			r.reset;
			r.play(SystemClock);
		}, { 
			if (isPaused, {
				this.resume
			}, {
				r.play(SystemClock);
			});
		});
		{btn3.value = 0}.defer;
	}
	
	
	// stop timer altogether & cleanup
	stop {
		if (r.isPlaying, {
			r.stop;
	//		["loopedTime, currTime, timePaused", 
	//			loopedTime,  currTime, timePaused.ceil].postln;
			this.endText;
			loopedTime=0;
			timePaused=0;
			currTime = 0;
			notInRout = true;
			{ btn.value = 0 }.defer;
		});
		{ btn3.value = 1 }.defer;
	}
	
	
	close  { 
		if (r.isPlaying, {r.stop}); 
		{win.close}.defer;
		allScets.remove(this);
	}

	setColor {|col| 
		if(col.isNil, {col = Color.rand; });
		{ win.view.background = col}.defer
	}
	
	winOnTop {|val=true| win.alwaysOnTop_(val) }
	

	// flash window when alerting
	alert { arg remind, wild; 
		var freqs, num, arr, pan, waitTime, col, nextSectName;
		col = Color.new255(160, 210, 255); // cornflower blue
		arr = (2..11)*220;
		if (wild, {
			num = 15;
			// amp = 0.2;
			freqs = ((Array.geom(6, 1, 5).scramble * 0.5) 
				+ [660, 880].choose
			).trunc;
			waitTime = rrand(0.05, 0.075);
			}, {
			num = 20;
			// amp = 0.3;
			freqs = if (remind){arr++arr}{(21.. 2)*110};
			waitTime = 0.05;
		});
		
		Routine({ 	
			num.do{ |i|	
				if(r.isPlaying) {
					if (snd){
						pan = if (i%2==0, {-1}, {1});
						this.playSynth(freq: freqs[i], pan: pan); 
				};
					{	
						win.view.background= col;
						win.alpha = i.mod(2);
					}.defer;
					waitTime.yield
				}
			};
			{ win.view.background = color; win.alpha = 1;}.defer;
		}).play;
	}
	

	// format time and alert str to string, then set GUI display 
	setText { |secs, dir |
		var val;
		val = if(dir, { totalTime - secs }, { secs });
		{ text.string = val.asTimeString1 }.defer;
	}
	
	setMsg  { |string, secDur | 
		var timeStr;
		timeStr = secDur.asTimeString1;
		// if only 1 section, don't print "Part 1"
		if(secsArr.size == 1, { string = "Playing" });
		{ info.string = string }.defer;
		[string, "duration:  "++timeStr].postln; 
	}

	// setSlider
	setSlider { | ind, dir=false | 
		var val, range;
		if (toggle, {
			range = currSectionDur;
			ind  = if(notInRout, {currSectionDur}, {currSctnBeat});
			dir = true;
		}, {
			range = totalTime;
		});
		
		val = if(dir.not, {1-(ind / range)}, { ind/range });
		{
		slide.lo = val;
		slide.range_(0.007);
		}.defer;
	}
	
	endText  {
		var sliderTime, textTime, tmp;
		if (timePaused > 0, {
			tmp = (totalTime + timePaused).ceil;
			{ info.string = tmp.asTimeString1 
			}.defer;
		}, {
			{ info.string = "total time" }.defer;
		});
		if(notInRout, {
			sliderTime = totalTime;
			textTime = totalTime
			}, {
			sliderTime = currTime;
			textTime = loopedTime + currTime;
		});
		("Done at"+textTime.asTimeString1).postln;
		this.setText(textTime, false);
		this.setSlider(sliderTime, false); 
	}

	playSynth {|freq=3520, amp=0.3, pan=0|  
		Synth.new("ScetPing",
			[\freq,freq, \amp, amp, \pan, pan]
		) // freq = A
	}

	// main fn
	routine { 		
		r = Task({
			(totalTime).do{ |i|  
				currTime = i;
				notInRout = false;
				// looks to see if current second is at section boundary
				remind = secsArr.includes(i+1);
				lastIter = i == (totalTime-1);
				{ btn.value =  1 }.defer; // set play to reset
				
				if (i==0, {
					currSectionInd = 0;
					currSection = names[0];
					if (snd){ this.playSynth };
				// play tick if applies, with melody if wildcard
				// don't play if another reminder melody would play
				}, {
					if ((tick.notNil && remind.not), {
						if (((i%tick==0) && (lastIter.not)), {
							if (wild, {
								this.alert(false, true);
							}, {
								this.playSynth; 
							});
						});
					});
				});
				
				if (i==nextTxtUpdate, {
					currSectionDur = secsDiffs[currSectionInd];
					this.setMsg(currSection, currSectionDur);
				});
				
				currSctnBeat = i-nextTxtUpdate;
				currSctnBeatsRem = currSectionDur-currSctnBeat;
				
	//			[nextTxtUpdate, currSectionDur, currSctnBeat, 
	//				currSctnBeatsRem
	//			].postln;
				
				// reminder(s)
				// remind means curr second at section boundary
				if (remind, {
					if (lastIter, {
						this.alert(false, false);
					}, {	
						// boolean sets style of synth sequence
						currSectionInd = secsArr.indexOf(i+1)+1;
						currSection = names[currSectionInd];
						this.alert(true, false);
						nextTxtUpdate = i+1;
					});
				});				
				
				this.setSlider(i, dir);	
				
				if (toggle, {
					this.setText(loopedTime + i, false);
				}, {
					this.setText(currSctnBeatsRem, false);
				});
				
				// for looping
				if (loop && (i == (totalTime-1)), {
					loopedTime = loopedTime + totalTime;
					nextTxtUpdate = 0;
					1.yieldAndReset(loop);
				}, {
				1.wait
				});	
			};
		this.taskFinished
		});
	}

	taskFinished { 
		// Task finished
		// "Done".postln;
		notInRout = true;	
		this.endText;
		loopedTime=0;
		nextTxtUpdate = 0;
		timePaused=0;
		currTime = 0;
		{ btn.value = 0 }.defer;
		{ btn3.value = 1 }.defer;
		this.setSlider(totalTime, false); // ensure at very end
	}

	resolution { 	
		^GUI.window.screenBounds.extent.asArray;
	}
	
	sound { arg status, s, tck, mel, amp=0.3;
		snd = status;
		if(status.not, { tick = nil; ^"sound off" });
		if(s.serverRunning.not, {
			"Scet: server not running".error; 
			// currTime = 0; // needed for this.stop
			^r.stop;
		 });
		server = s;
		vol = amp;
		if (tck.notNil){ tick = tck.time2secs }{tick=nil};
		wild = mel ? false; // bool
	}

	winBounds_ { | posW=1, posH=1|
		posW = posW.wrap(0, 1);
		posH = posH.wrap(0, 1);
		winBoundsCurr = [posW, posH];
		posH = posH	* (screenRes[1] -winSize[1] -28) + 4;
		posW = posW * (screenRes[0]-winSize[0] -8) + 4;
		{ win.bounds_(Rect(posW, posH, winSize[0], winSize[1]));
		win.front;
		}.defer;
	}

	winBounds { ^winBoundsCurr }	
	
	nextWinBounds {
		var currBounds, newBounds;
		if (allScets.isEmpty, {
			^[1, 1]
			}, {
			currBounds = allScets.last.winBounds;
			^currBounds.collect({|i| 
				if(i >= 0.5, {i - 0.025}, {i + 0.025}) 
			});
		});
	}

	////    START GUI    //////
	// make window
	winFn { |dir|
		var smfont, font, btnCol, emColor, stringColor; 
		btnCol = Color.gray;	
		stringColor = Color.white;
		color = Color(0.2, 0.1843, 0.2235, 0.93); // dark gray from _f0
		emColor = Color.yellow(0.9);
		smfont= Font("Arial", 10);
		win = GUI.window.new(
			"Timer", Rect(0, 0, winSize[0], winSize[1]), 
			resizable: false, border: false
		);
		
		this.winBounds_(*this.nextWinBounds);
		win.view.decorator = FlowLayout(win.view.bounds);
		win.view.background = color;
		win.alwaysOnTop_(true);
			
		// slide
		slide = SCRangeSlider(win, Rect(0,0, winSize[0]-8, 9));
		slide.knobColor_(emColor);
		slide.background_(Color.gray);
		slide.lo = if (dir.not, {1.0}, {0.0}); // initial display
		slide.range_(0.01);
		
		// time	
		text = GUI.staticText.new(win, Rect(0, 0, 57, 14));
		text.font_(Font("Monaco", 12));
		text.stringColor_(stringColor);
		this.setText(secsDiffs[0], dir); // initial value
			
		// section name
		info = GUI.staticText.new(win, Rect(0, 0, 40, 14));
		info.font_(smfont);
		info.stringColor_(stringColor);
		info.string  = "";
		
		////    BUTTONS    //////
		
		// TOGGLE DISPLAY MODE
		btn4 = GUI.button.new(win, Rect(0, 0, 15, 16));
		btn4.states = [
				["t",Color.white,btnCol],
				["t",emColor,Color.gray]
		];
		btn4.font_(smfont);
		btn4.action = { arg butt;
			if (butt.value==0){
				toggle = false;
			}{
				toggle = true;
			};	
		};
		
		// STOP / CLOSE
		btn3 = GUI.button.new(win, Rect(0, 0, 40, 16));
		btn3.states = [
			["stop",Color.white, btnCol], 
			["close", emColor, btnCol]
		];
		btn3.font_(smfont);
		btn3.action = { arg butt;
			if (butt.value==1, { 
				this.stop; 
			}, {
				this.close
			});	
		};
		
		// START
		btn = GUI.button.new(win, Rect(0, 0, 40, 16));
		btn.states = [
				["play",Color.white,btnCol],
				["pause",Color.white,Color.gray]
		];
		btn.font_(smfont);
		btn.action = { arg butt;
			if (butt.value==1){
				this.play
			}{
				this.pause;
			};	
		};
		win.onClose_( this.stop );
		win.front;
	}
	////    END GUI    //////
	
}


